//+------------------------------------------------------------------+
//|                                                    Publisher.mq4 |
//|                                                       Greatshore |
//|                                               greatshore@live.cn |
//+------------------------------------------------------------------+
#property copyright "Greatshore"
#property link      "greatshore@live.cn"

#define GVARUP        "Publisher_UpdateTime"        // ʱȫֱ
#define GVARHASH      "Publisher_LastOrdersHash"    // һγֲֵHash
#define DATAPATH      "Publisher\\"                 // ļĿ¼
#define VARPREFIX     "<!!-"                        // 滻ǰ׺
#define VARSUFFIX     "--->"                        // 滻׺
#define REALSTR       "$"                           // ʾʵֵ
#define DAYSECOND     86400                         // ÿ
#define ORDERPART     7                             // ÿֲĿ

//---- input parameters
extern int     UpdatePeriod   = 15;                          // ڣӣ5ӣ0ʾֲб仯
extern bool    ShowPending    = true;                        // ǷʾҵϢ
extern int     HistoryNum     = 1;                           // ʷ׵Ŀ
extern int     HistoryPeriod  = 2;                           // ʷ׵ڵλ0-1-, 2-ܣ3-
extern int     TZOffset       = 6;                           // ʱ
extern string  TZComment      = "Beijing Time:";             // ʱע
extern string  FTPPath        = "/forexbot";                 // ϴĿ¼
extern string  WebFileName    = "state.htm";                 // ϴļ
extern string  TemplateName   = "Publisher.template.htm";    // ҳʹõģļ
extern string  ShowAccount    = "$";                         // ʾ˻ţ$ʾʵ˻
extern string  ShowName       = "$";                         // ʾ˻$ʾʵ˻
extern string  ShowBroker     = "$";                         // ʾĹ˾$ʾʵʹ˾
extern bool    ShowTicket     = true;                        // Ƿʾ
extern bool    ShowOpenTime   = true;                        // Ƿʾʱ
extern bool    ShowSize       = true;                        // Ƿʾ
extern bool    ShowTPSL       = true;                        // Ƿʾֹ
extern bool    ShowSwap       = true;                        // ǷʾҹϢ
extern int     ShowProfitType = 2;                           // ʾʽ0-ʾ1-2-ֵ
extern bool    ShowComment    = false;                       // Ƿʾע
extern bool    ShowEquity     = true;                        // Ƿʾ˻ֵ
extern bool    ShowFreeMargin = true;                        // Ƿʾɱ֤
extern string  HiddenText     = "---";                       // ֵʾַ

string OpStr[] = {"buy", "sell", "buy limit", "sell limit", "buy stop", "sell stop"};

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
  if (!ShowSize) // ʾֲҹϢͻʾ
  {
    ShowSwap = false;
    if (ShowProfitType == 2)
      ShowProfitType = 1;
  }
  
  if ((UpdatePeriod < 5) && (UpdatePeriod > 0))
    UpdatePeriod = 5;

  return(0);
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
  GlobalVariableDel(GVARUP);
  GlobalVariableDel(GVARHASH);

  return(0);
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
  datetime LastUpdate, CurrentTime;
  bool NeedUpdate;
  
  CurrentTime = TimeCurrent();
  LastUpdate  = GlobalVariableGet(GVARUP);
  if (UpdatePeriod == 0)
    NeedUpdate = CheckOrderChange();
  else
    NeedUpdate = (CurrentTime - LastUpdate) / 60 >= UpdatePeriod;
  if (NeedUpdate)
  {
    GlobalVariableSet(GVARUP, CurrentTime);
    GeneratePage(DATAPATH + WebFileName);
    SendFTP(DATAPATH + WebFileName, FTPPath);
    FileDelete(DATAPATH + WebFileName);
  }
  
  return(0);
}

//+------------------------------------------------------------------+

// ===== ɳֱֲҳ =====
void GeneratePage(string FileName)
{
  int fin, fout, i, j;
  string linestr;
  
  fin  = FileOpen(DATAPATH + TemplateName, FILE_READ  | FILE_BIN);
  if (fin < 0)
    Print("Error in reading template file.");
  else
  {
    fout = FileOpen(DATAPATH + WebFileName,  FILE_WRITE | FILE_CSV, ' ');
    while (!FileIsEnding(fin))
    {
      linestr = GetOneLine(fin);
      if (StringLen(linestr) > 0)
      {
        i = StringFind(linestr, VARPREFIX);
        if (i >= 0)
          ReplaceVarStr(fout, linestr, i);
        else
          FileWrite(fout, linestr);
      }
    }
    FileClose(fin);
    FileClose(fout);
  }  
}

// ===== ļжȡһ =====
string GetOneLine(int InFile)
{
  int i, j;
  string ret, char;
  
  ret = "";
  while (!FileIsEnding(InFile))
  {
    char = FileReadString(InFile, 1);
    if ((char == "\r") || (char == "\n"))
      break;
    else
      ret = ret + char;
  }
  return(ret);
}

// ===== 滻ַ =====
void ReplaceVarStr(int OutFile, string linestr, int start)
{
  string VarName, LeftStr, RightStr, MidStr;
  int end, i;
  
  end = StringFind(linestr, VARSUFFIX, start);
  i = start + StringLen(VARPREFIX);
  if (start > 0)
    LeftStr  = StringSubstr(linestr, 0, start);
  RightStr = StringSubstr(linestr, end + StringLen(VARSUFFIX));
  MidStr   = "";
  VarName  = StringSubstr(linestr, i, end - i);
  if (VarName == "ACCOUNTNUM")         // ˻
  {    
    if (ShowAccount == REALSTR)
      MidStr = AccountNumber();
    else
      MidStr = ShowAccount;
  }
  else if (VarName == "ACCOUNTNAME")   // ˻
  {
    if (ShowName == REALSTR)
      MidStr = AccountName();
    else
      MidStr = ShowName;
  }
  else if (VarName == "BROKER")        // ˾
  {
    if (ShowBroker == REALSTR)
      MidStr = AccountCompany();
    else
      MidStr = ShowBroker;
  }
  else if (VarName == "CURRENCY")      // ˻
    MidStr = AccountCurrency();
  else if (VarName == "EQUITY")        // ˻ֵ
  {
    if (ShowEquity)
      MidStr = DoubleToStr(AccountEquity(), 2);
    else
      MidStr = HiddenText;
  }
  else if (VarName == "FREEMARGIN")    // ñ֤
  {
    if (ShowFreeMargin)
      MidStr = DoubleToStr(AccountFreeMargin(), 2);
    else
      MidStr = HiddenText;
  }
  else if (VarName == "UPDATETIME")    // ʱ
  {
    MidStr = TimeToStr(TimeCurrent());
    if ((TZOffset != 0) && (StringLen(TZComment) > 0))
    MidStr = MidStr + " [" + TZComment +  TimeToStr(TimeCurrent() + TZOffset * 3600) + "]";
  }
  else if (VarName == "HISTORYPERIOD")  // ʷ
  {
    if (HistoryNum > 0)
    {
      MidStr = "    last " + HistoryNum;
      switch (HistoryPeriod)
      {
        case 0 : MidStr = MidStr + " order"; break;
        case 1 : MidStr = MidStr + " day"; break;
        case 2 : MidStr = MidStr + " week"; break;
        case 3 : MidStr = MidStr + " month";
      }
      if (HistoryNum > 1) 
        MidStr = MidStr + "s";
    }
    else
      MidStr = "";    
  }
  else if (VarName == "HOLDINGORDERS")    // ֲб
    WriteHoldingOrders(OutFile);
  else if ((VarName == "PENDINGORDERS") && ShowPending)    // ҵб
    WritePendingOrders(OutFile);
  else if ((VarName == "CLOSEDORDERS") && (HistoryNum > 0))    // ʷ׵б
    WriteClosedOrders(OutFile);
  else
    MidStr = HiddenText;
  
  FileWrite(OutFile, LeftStr+ MidStr + RightStr);
}

// ===== дֲб =====
void WriteHoldingOrders(int OutFile)
{
  int i, c, op;
  string symb;
  
  for (i = 0, c = 0; i < OrdersTotal(); i++)
  {
    OrderSelect(i, SELECT_BY_POS);
    op = OrderType();
    if (op < 2)
    {
      symb = OrderSymbol();
      c++;
      WriteLeftColums(OutFile, c, op, symb, MarketInfo(symb, MODE_DIGITS));
      WriteSwapProfit(OutFile, op, symb);
      WriteComment(OutFile);
      FileWrite(OutFile, "</tr>");
    }
  }
}

// ===== дҵб =====
void WritePendingOrders(int OutFile)
{
  int i, c, op;
  string symb, str = "";
  datetime exp;
  
  for (i = 0, c = 0; i < OrdersTotal(); i++)
  {
    OrderSelect(i, SELECT_BY_POS);
    op = OrderType();
    if (op > 1)
    {
      symb = OrderSymbol();
      c++;
      WriteLeftColums(OutFile, c, op, symb, MarketInfo(symb, MODE_DIGITS));
      exp = OrderExpiration();  // ʱ
      if (exp > 0)
        str = TimeToStr(exp);
      FileWrite(OutFile, "<td class=msdate nowrap>" + str + "</td>");
      WriteComment(OutFile);
      FileWrite(OutFile, "</tr>");
    }
  }
}

// ===== дʷ׵ =====
void WriteClosedOrders(int OutFile)
{
  int i, c, end, op, d;
  string symb, str = "";
  datetime StartTime, OpenTime;

  // ʷ¼  
  if (HistoryPeriod == 0)
    end = OrdersHistoryTotal() - HistoryNum;
  else
  {
    end = 0;
    StartTime = GetStartTime(TimeCurrent());
  }
    
  for (i = OrdersHistoryTotal() - 1, c = 0; i >= 0; i--)
  {
    OrderSelect(i, SELECT_BY_POS, MODE_HISTORY);
    OpenTime = OrderOpenTime();
    if ((HistoryPeriod != 0) && (OpenTime < StartTime))
      break;
      
    op = OrderType();
    if (op < 2)
    {
      c++;
      symb = OrderSymbol();
      d = MarketInfo(symb, MODE_DIGITS);
      WriteLeftColums(OutFile, c, op, symb, d);
      // ƽʱ估ƽּ
      FileWrite(OutFile, "<td class=msdate nowrap>" + TimeToStr(OrderCloseTime()) + "</td>");
      FileWrite(OutFile, "<td>" + DoubleToStr(OrderClosePrice(), d) + "</td>");

      WriteSwapProfit(OutFile, op, symb);
      WriteComment(OutFile);
      FileWrite(OutFile, "</tr>");
    }
  }
}

// ===== дǰ벿 =====
void WriteLeftColums(int OutFile, int c, int op, string symb, int d)
{
  string str, str2;
  int i, p, cl;
  double SL, TP;

  // һУбɫ
  if (c % 2 == 1)
    str = ">";
  else
    str = " bgcolor=#E0E0E0>";
  FileWrite(OutFile, "<tr align=right" + str);
      
  // Ticket
  if (ShowTicket)
    str = OrderTicket();
  else
    str = HiddenText;
  FileWrite(OutFile, "<td>" + str + "</td>");
     
  // ׻ҶԺͿַ
  FileWrite(OutFile, "<td>" + symb + "</td>");
  FileWrite(OutFile, "<td>" + OpStr[op] + "</td>");

  // 
  if (ShowSize)
    str = DoubleToStr(OrderLots(), 2);
  else
    str = HiddenText;
  FileWrite(OutFile, "<td class=mspt>" + str + "</td>");

  // ʱ
  if (ShowOpenTime)
    str = TimeToStr(OrderOpenTime());
  else
    str = HiddenText;
  FileWrite(OutFile, "<td class=msdate nowrap>" + str + "</td>");

  // ּ
  FileWrite(OutFile, "<td>" + DoubleToStr(OrderOpenPrice(), d) + "</td>");

  // ֹ
  if (ShowTPSL)
  {
    SL = OrderStopLoss();
    TP = OrderTakeProfit();
    if (OrderCloseTime() > 0)  // Ѿƽֵĵ
    {
      p  = MathPow(10, d);
      cl = OrderClosePrice() * p;
      if (cl == SL * p) // ֹ
        str = " bgcolor=\"#FFA0A0\">";
      else
        str = ">";
      if (cl == TP * p) // ֹӮ
        str2 = " bgcolor=\"#60F060\">";
      else
        str2 = ">";
    }
    else
    {
      str  = ">";
      str2 = ">";
    }  
    str  = str  + DoubleToStr(SL, d);
    str2 = str2 + DoubleToStr(TP, d);
  }
  else
  {
    str  = ">" + HiddenText;
    str2 = ">" + HiddenText;
  }
  FileWrite(OutFile, "<td" + str  + "</td>");
  FileWrite(OutFile, "<td" + str2 + "</td>");
}

// ===== дϢͻ =====
void WriteSwapProfit(int OutFile, int op, string symb)
{
  double cp;
  string str;
  
  // ҹϢ
  if (ShowSwap)
    str = DoubleToStr(OrderSwap(), 2);
  else
    str = HiddenText;
  FileWrite(OutFile, "<td class=mspt>" + str + "</td>");
  
  // 
  switch (ShowProfitType)
  {
    case 0 :
         str =  ">" + HiddenText;
         break;
    case 1 :
         if (op == OP_BUY)
           cp = MarketInfo(symb, MODE_BID);
         else
           cp = MarketInfo(symb, MODE_ASK);
         str = ">" + DoubleToStr((cp - OrderOpenPrice()) / MarketInfo(symb, MODE_POINT), 0) + "p";
         break;
    case 2 :
         str = " class=mspt>" + DoubleToStr(OrderProfit(), 2);
  }
  FileWrite(OutFile, "<td" + str + "</td>");
}

// ===== дע =====
void WriteComment(int OutFile)
{
  string str;

  str = OrderComment();
  if (!ShowComment && (StringLen(str) > 0))
    str = HiddenText;
  FileWrite(OutFile, "<td>" + str  + "</td>");
}

// ===== ֲûб仯 =====
bool CheckOrderChange()
{
  int LastOrdersHash, CurrnetOrdersHash;
  
  LastOrdersHash    = GlobalVariableGet(GVARHASH);
  CurrnetOrdersHash = GetOrdersHash(OrdersTotal());
  if (CurrnetOrdersHash != LastOrdersHash)
  {
    GlobalVariableSet(GVARHASH, CurrnetOrdersHash);
    return(true);
  }
  else
    return(false);
}

// ===== 㵱ǰֲֵHash =====
int GetOrdersHash(int OrdersCount)
{
  int Orders[][ORDERPART], i, j, k, Hash = 0;
  string OrderSymb, str;

  ArrayResize(Orders, OrdersCount);
  
  // ֲת
  for (i = 0; i < OrdersCount; i++)
  {
    OrderSelect(i, SELECT_BY_POS);
    OrderSymb = OrderSymbol();
    k = MarketInfo(OrderSymb, MODE_POINT);
    
    Orders[i][0] = OrderTicket();
    Orders[i][1] = SymbolToInt(OrderSymb);
    Orders[i][2] = OrderType() << 24 + OrderLots() * 100;
    Orders[i][3] = OrderOpenPrice() / k;
    Orders[i][4] = OrderTakeProfit() / k;
    Orders[i][5] = OrderStopLoss() / k;
    Orders[i][6] = OrderSwap() * 100;
  }
  if (OrdersCount > 0)
  {
    ArraySort(Orders);
    // Hashֵ
    for (i = 0; i < OrdersCount; i++)
      for (j = 0; j < ORDERPART; j++)
        for (k = 3; k >= 0; k--)
          Hash += (Hash << 5) + ((Orders[i][j] >> (k * 8)) & 0xFF);
  }
  
  return(Hash);
}

// ==== ʷֲʼʱ ====
datetime GetStartTime(datetime EndTime)
{
  datetime StartTime;
  int y, m, d;
  
  switch (HistoryPeriod)
  {
    case 1 :
        StartTime = EndTime - (HistoryNum - 1) * DAYSECOND;
        break;
    case 2 :
        StartTime = EndTime - HistoryNum * 7 * DAYSECOND;
        while (TimeDayOfWeek(StartTime) > 0)
          StartTime += DAYSECOND;
        break;
    case 3 :
        StartTime = EndTime - (HistoryNum - 1) * 30 * DAYSECOND;
  }
  y = TimeYear(StartTime);
  m = TimeMonth(StartTime);
  if (HistoryPeriod == 3)
    d = 1;
  else
    d = TimeDay(StartTime);
  StartTime = StrToTime(y + "." + m + "." + d);

  return(StartTime);
}

// ===== ѻҶת =====
int SymbolToInt(string Symb)
{
  int i, r;
  
  for (r = 0, i = 0; i < StringLen(Symb); i++)
    r += r << 5 + StringGetChar(Symb, i);
  return(r);
}

